#ifndef CHIP_STM32G0XX_REGS_USART_H
#define CHIP_STM32G0XX_REGS_USART_H

#include "chip_dev_spec_features.h"

#define CHIP_SUPPORT_USART_PRESC        1
#define CHIP_SUPPORT_USART_FIFO         1
#define CHIP_SUPPORT_USART_SYNC_SLAVE   1
#define CHIP_SUPPORT_USART_TCBGT_FLAG   1

#include "stm32_usart_v2_regs.h"

/* поддерживаемые возможности UART для заданного номера UART и заданного устройства */
#define CHIP_UART_FEATURES_NOT_PRESENT        0  /* в данном устройстве UART с этим номер отсутствует */
#define CHIP_UART_FEATURES_BASIC              1  /* поддерживаются только базовые функции */
#define CHIP_UART_FEATURES_FULL               2  /* поддерживаются все функции */
#define CHIP_UART_FEATURES_LP                 3  /* поддерживаются функции LPUART */


#define CHIP_REGS_USART1         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART1)
#define CHIP_USART1_FEATURES     CHIP_UART_FEATURES_FULL

#define CHIP_REGS_USART2         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART2)
#if CHIP_DEV_SUPPORT_USART2_ICLKSEL
    #define CHIP_USART2_FEATURES     CHIP_UART_FEATURES_FULL
#else
    #define CHIP_USART2_FEATURES     CHIP_UART_FEATURES_BASIC
#endif

#if CHIP_DEV_SUPPORT_USART3
    #define CHIP_REGS_USART3         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART3)
    #if CHIP_DEV_SUPPORT_USART3_ICLKSEL
        #define CHIP_USART3_FEATURES     CHIP_UART_FEATURES_FULL
    #else
        #define CHIP_USART3_FEATURES     CHIP_UART_FEATURES_BASIC
    #endif
#else
    #define CHIP_USART3_FEATURES     CHIP_UART_FEATURES_NOT_PRESENT
#endif

#if CHIP_DEV_SUPPORT_USART4
    #define CHIP_REGS_USART4         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART4)
    #define CHIP_USART4_FEATURES     CHIP_UART_FEATURES_BASIC
#else
    #define CHIP_USART4_FEATURES     CHIP_UART_FEATURES_NOT_PRESENT
#endif

#if CHIP_DEV_SUPPORT_USART5
    #define CHIP_REGS_USART5         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART5)
    #define CHIP_USART5_FEATURES     CHIP_UART_FEATURES_BASIC
#else
    #define CHIP_USART5_FEATURES     CHIP_UART_FEATURES_NOT_PRESENT
#endif


#if CHIP_DEV_SUPPORT_USART6
    #define CHIP_REGS_USART6         ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_USART6)
    #define CHIP_USART6_FEATURES     CHIP_UART_FEATURES_BASIC
#else
    #define CHIP_USART6_FEATURES     CHIP_UART_FEATURES_NOT_PRESENT
#endif
#define CHIP_USART6_FULL             0

#define CHIP_REGS_LPUART1        ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_LPUART1)
#define CHIP_LPUART1_FEATURES    CHIP_UART_FEATURES_LP

#if CHIP_DEV_SUPPORT_LPUART2
    #define CHIP_REGS_LPUART2        ((CHIP_REGS_USART_T *) CHIP_MEMRGN_ADDR_PERIPH_LPUART2)
    #define CHIP_LPUART2_FEATURES    CHIP_UART_FEATURES_LP
#else
    #define CHIP_LPUART2_FEATURES    CHIP_UART_FEATURES_NOT_PRESENT
#endif



#define LPRINTF_UART_FEATURES_(num)   LPRINTF_UART_FEATURES__(num)
#define LPRINTF_UART_FEATURES__(num)  CHIP_USART ## num ## _FEATURES

#define CHIP_USART_SUPPORT_SYNC(n)       1
#define CHIP_USART_SUPPORT_FIFO(n)       (LPRINTF_UART_FEATURES_(n) == CHIP_UART_FEATURES_FULL)
#define CHIP_USART_SUPPORT_PRESC(n)      (LPRINTF_UART_FEATURES_(n) == CHIP_UART_FEATURES_FULL)

#define CHIP_LPUART_SUPPORT_FIFO(n)     1
#define CHIP_LPUART_SUPPORT_FIFO(n)     1


#endif // CHIP_STM32G0XX_REGS_USART_H
